% This script is for batch processing "Read_TrackMatedata_xml.m" data and
% save the wanted results (Mean droplet pixel intensity,Total droplet 
% Intensity, Number of droplets within each frame, sum of total droplet
% intensity within each frame) in a csv file.

%In case there is a problem in line17 (writecell), just create a xlsx file
%by yourself in the folder and rename it as 'Trackmate_xml.xlsx' before
%running this problem. And self input the excel header.

% clear

disp('Please select the particle frame xml files generated by TrackMate.');
[filename,path] = uigetfile('multiselect','on','.xml','Select the file to convert');
addpath(path)
cd(path)

checkforfile = isfile('Trackmate_xml.xlsx');
if checkforfile == 0
    header = {'filename','Total Droplet Intensity','Mean pixel Intensity','Number of droplets within each frames','Sum of total droplet intensity'};
    writecell(header,fullfile(pwd, 'Trackmate_xml.xlsx'),'Range','A1');
    N = 0;
else
    N = size(xlsread('Trackmate_xml.xlsx'),1);
end
    
if ischar(filename)
    N_file = 1;
else
    N_file = length(filename);
end

for i = 1:N_file
    if N_file==1
         disp(filename)
        [MeanInt,MaxInt,TotInt,spotN_T] = Read_TrackMatedata_xml(filename);
    else
        disp(filename{i})
        [MeanInt,MaxInt,TotInt,spotN_T] = Read_TrackMatedata_xml(filename{i});
    end
       
    for j = 1:length(MeanInt)
        MeanInt_temp = MeanInt{j}';
        MaxInt_temp = MaxInt{j}';
        TotInt_temp = TotInt{j}';
        
        AA = strcat('A',num2str(N+2));
        BB = strcat('B',num2str(N+2));
        DD = strcat('D',num2str(N+2));
        EE = strcat('E',num2str(N+2));
        if N_file==1
            writecell({filename},'Trackmate_xml.xlsx','Range',AA)
            writematrix(spotN_T','Trackmate_xml.xlsx','Range',DD)
            writematrix(sum(TotInt_temp),'Trackmate_xml.xlsx','Range',EE)
        else
            writecell(filename(i),'Trackmate_xml.xlsx','Range',AA)
            writematrix(spotN_T','Trackmate_xml.xlsx','Range',DD)
            writematrix(sum(TotInt_temp),'Trackmate_xml.xlsx','Range',EE)
        end
        writematrix([TotInt_temp,MeanInt_temp],'Trackmate_xml.xlsx','Range',BB)
        N = size(xlsread('Trackmate_xml.xlsx'),1);
    end
end
